/************************************************************************
 * Purpose:     A program to experiment with point-to-point
 *              communications. 
 *
 * Author:      CPS615 - Spring 2000
 *
 ************************************************************************/

#include	<stdio.h>
#include	<mpi.h>

#define ping 101
#define pong 101

float buffer[100000];

void processor_A (int);
void processor_B (void);

void main ( int argc, char *argv[] )
{
     int ierror, rank, size, p;

     MPI_Init(&argc, &argv);

     MPI_Comm_rank(MPI_COMM_WORLD, &rank);

    /* Find out number of processes */
    MPI_Comm_size(MPI_COMM_WORLD, &p);

     if (rank == 0) processor_A(p);
     else processor_B();

     MPI_Finalize();

}

void processor_A(int p )
{

    int i, ierror, dest;
    MPI_Status status;

    double start, finish, time;

    extern float buffer[100000];

    int length=100000;

    printf("Rank\tTotal Time\tTransfer Rate\n");

     for (dest = 1; dest <= p - 1; dest++)
     { 

        start = MPI_Wtime();

        MPI_Ssend(buffer, length, MPI_FLOAT, dest, ping,
                      MPI_COMM_WORLD);

        MPI_Recv(buffer, length, MPI_FLOAT, dest, pong,
                     MPI_COMM_WORLD, &status);

        finish = MPI_Wtime();

        time = finish - start;

 	printf("rank:%d\t%f\t%f\n", dest, time/200.,
               (float)(2 * 8 * 100 * length)/time);
    }

}

void processor_B( void )
{
    int i, ierror;
    MPI_Status status;

    extern float buffer[100000];

    int length=100000;

    MPI_Recv(buffer, length, MPI_FLOAT, 0, ping,
                         MPI_COMM_WORLD, &status);

    MPI_Ssend(buffer, length, MPI_FLOAT, 0, pong,
                         MPI_COMM_WORLD);
}

